﻿Imports System.Drawing

Module ThereminoMCA_Program
    Friend ValidPulses As Single
    Friend TotalSeconds As Single
    Friend PulsesPerSec As Single
    Friend IntegrationTime As Single
    Friend Slot_Counter As Int32
    Friend Slot_BinsFirstSlot As Int32
    Friend BinsNumSlots As Int32
    Friend AutoPolarityTest As Boolean

    Friend Tomy_StartIsotopeIndex As Int32
    Friend Form1_StartWindowState As Int32
    Friend Form2_StartWindowState As Int32
    Friend Form3_StartWindowState As Int32
    Friend Form2_StartVisible As Boolean
    Friend Form3_StartVisible As Boolean
    Public Const MAX_BIN_INDEX As Int32 = 4095
    Friend Isotopes As cIsotopes = New cIsotopes
    Friend AudioIn As cAudioIn = New cAudioIn
    Friend Spectrometer As cSpectrometer = New cSpectrometer
End Module


Public Class Form_Main

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        MemoryMappedFile_Init()
        cmb_Bins.SelectedIndex = 1
        cmb_Sampling.SelectedIndex = 5
        cmb_PulsePolarity.SelectedIndex = 2
        Load_INI()
        SetLocales()
        InitPictureboxImage(PBox_Spectrum)
        Spectrometer.Picture_Box = PBox_Spectrum
        Isotopes.ListIsotopes()
        ' -------------------------------------------
        'EventsAreEnabled = True
        Spectrometer.InitAll()
        Set_Props()
        Form_Equalizers.CreateLinearityCurve()
        Form_Equalizers.CreateHeightCurve()
        Form_Equalizers.EnableDisableControls()
        Form_Pulses.SetProps()
        StartAudioReader()
        AllBinsToZero()
        Me.Text = AppTitleAndVersion("Theremino MCA")
        EventsAreEnabled = True
        GroupBox_AudioInput.Focus()
        EventsAreEnabled = False


        '' ------------------------------------------- Save left position and invibilize them
        'Dim old1 As Int32 = Form_Pulses.Left
        'Dim old2 As Int32 = Form_Equalizers.Left
        'Form_Pulses.Left = -9999
        'Form_Equalizers.Left = -9999
        '' ------------------------------------------- Start windows
        'EventsAreEnabled = True
        'Me.WindowState = CType(Form1_StartWindowState, FormWindowState)
        'EventsAreEnabled = False
        'Form_Pulses.Show(Me)
        'Form_Pulses.Visible = Form2_StartVisible
        'Form_Pulses.Left = old1
        'Form_Pulses.WindowState = CType(Form2_StartWindowState, FormWindowState)
        'Form_Equalizers.Show(Me)
        'Form_Equalizers.Visible = Form3_StartVisible
        'Form_Equalizers.Left = old2
        'Form_Equalizers.WindowState = CType(Form3_StartWindowState, FormWindowState)
        'DockAllWindows()


        ' ------------------------------------------- Start windows (NEW with FadeIn)
        EventsAreEnabled = True
        Me.WindowState = CType(Form1_StartWindowState, FormWindowState)
        EventsAreEnabled = False
        Form_Pulses.Show(Me)
        Form_Pulses.Visible = Form2_StartVisible
        Form_Pulses.WindowState = CType(Form2_StartWindowState, FormWindowState)
        Form_Equalizers.Show(Me)
        Form_Equalizers.Visible = Form3_StartVisible
        Form_Equalizers.WindowState = CType(Form3_StartWindowState, FormWindowState)
        DockAllWindows()

        ' ------------------------------------------- Txt UserText
        txt_UserText.SelectionStart = 9999
        txt_UserText.SelectionLength = 0
        txt_UserText.Focus()
        ' ------------------------------------------- Tomy area
        EnableDisableTomy()
        ' ------------------------------------------- FadeIn
        Forms_FadeTo(1, 400)
        ' ------------------------------------------- Test StopTimer and Start
        TestTimerBeforeToStart()
        TimerDraw.Interval = 100
        TimerDraw.Start()
        Timer10Hz.Interval = 100
        Timer10Hz.Start()
        Timer1Sec.Interval = 1000
        Timer1Sec.Start()
        ' ------------------------------------------- start with a good wave in the PulseShapeVisualizer 
        AudioIn.Scope_Clear()
        ' -------------------------------------------
        EventsAreEnabled = True
    End Sub

    Private Sub Form_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.FormClosing
        EventsAreEnabled = False ' do not permit to save the ini file ( already saved from form2 )
        Forms_FadeTo(0, 500)
        Save_INI()
        Me.Refresh()
        e.Cancel = False
        TimerDraw.Stop()
        Timer1Sec.Stop()
        AudioIn.RecordStop()
    End Sub

    Private Sub Form_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
        DockAllWindows()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        If Me.WindowState = FormWindowState.Minimized Then Return
        InitPictureboxImage(PBox_Spectrum)
        Spectrometer.Picture_Box = PBox_Spectrum
        Spectrometer.Draw()
        DockAllWindows()
    End Sub

    Friend Sub DockAllWindows()
        Form_Pulses.SetSnap()
        Form_Equalizers.SetSnap()
        Form_Tomy.SetSnap()
    End Sub


    ' =======================================================================================
    '   MENU FILE
    ' =======================================================================================
    Private Sub Menu_File_LoadConfiguration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_LoadConfiguration.Click
        EventsAreEnabled = False
        LoadConfiguration()
        Set_Props()
        Form_Pulses.SetProps()
        Form_Equalizers.CreateLinearityCurve()
        Form_Equalizers.CreateHeightCurve()
        StartAudioReader()
        EventsAreEnabled = True
    End Sub
    Private Sub Menu_File_SaveConfigurationAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveConfigurationAs.Click
        SaveConfigurationAs()
    End Sub
    Private Sub Menu_File_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SaveImage.Click
        SaveImage("ThereminoMCA_", Me)
    End Sub
    Private Sub Menu_File_SavePlotImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_SavePlotImage.Click
        SaveImage("SPECTRUM_", GroupBox_SpectrumData)
    End Sub
    Private Sub Menu_File_ExportPulseHeight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_ExportPulseHeight.Click
        SaveHistogramFile(chk_ExportWithHeader.Checked, txt_DecimalSeparator.Text, txt_FieldSeparator.Text)
    End Sub
    Private Sub Menu_File_ImportToRef1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_ImportToRef1.Click
        If LoadHistogramFile(1) Then btn_Reference1.Checked = True
    End Sub
    Private Sub Menu_File_ImportToRef2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_ImportToRef2.Click
        If LoadHistogramFile(2) Then btn_Reference2.Checked = True
    End Sub
    Private Sub Menu_File_ImportToRef3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_ImportToRef3.Click
        If LoadHistogramFile(3) Then btn_Reference3.Checked = True
    End Sub
    Private Sub Menu_File_ImportToBKG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_ImportToBKG.Click
        If LoadHistogramFile(0) Then btn_UseBkg.Enabled = True : btn_UseBkg.Checked = True
    End Sub
    Private Sub Menu_File_Exit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_File_Exit.Click
        Me.Close()
    End Sub


    ' =======================================================================================
    '   MENU TOOLS
    ' =======================================================================================
    Private Sub SubMenuTools_AutoZeroTrim_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuTools_AutoZeroTrim.Click
        If MsgBox("To do this the BaseLine restoring will be disabled" & vbCrLf & _
                  " and the Pulse shape visualizer params changed to see the background" & vbCrLf & vbCrLf & _
                  "Do the Auto zero trim ?", MsgBoxStyle.YesNo) <> MsgBoxResult.Yes Then Return
        If MsgBox("Remember to disconnect the PMT ( the BNC cable )" & vbCrLf & vbCrLf & _
                  "Do the Auto zero trim ?", MsgBoxStyle.YesNo) <> MsgBoxResult.Yes Then Return
        '
        ' ---------------------------------------------------------------------------- prepare
        chk_BlrEnable.Checked = False
        Set_Props()
        Form_Pulses.txt_MaxEnergy.NumericValueInteger = 3200
        Form_Pulses.txt_MinEnergy.NumericValueInteger = 0
        Form_Pulses.tk_SizeX.Value = 10
        Form_Pulses.tk_SizeY.Value = 59
        Form_Pulses.tk_PosY.Value = 50
        Form_Pulses.btn_Run.Checked = True
        Form_Pulses.btn_Normalized.Checked = False
        Form_Pulses.SetProps()
        ' ---------------------------------------------------------------------------- do the test
        txt_AudioZero.NumericValueInteger = 0
        Set_Props()
        AudioIn.PeakMeter_Negative = 999999
        AudioIn.PeakMeter_Positive = -999999
        Threading.Thread.Sleep(500)
        Dim v As Int32 = CInt((9 - (AudioIn.PeakMeter_Positive + AudioIn.PeakMeter_Negative) / 2) / AudioIn.AudioGain)
        txt_AudioZero.NumericValueInteger = v
        Set_Props()
    End Sub


    ' =======================================================================================
    '   MENU LANGUAGE
    ' =======================================================================================
    Private Sub Menu_Language_DropDownOpening(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language.DropDownOpening
        For Each item As ToolStripMenuItem In Menu_Language.DropDownItems
            If item.Name.EndsWith(Language, StringComparison.InvariantCultureIgnoreCase) Then
                item.CheckState = CheckState.Checked
            Else
                item.CheckState = CheckState.Unchecked
            End If
        Next
    End Sub
    Private Sub Menu_Language_Deutsch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Deutsch.Click
        Language = "Deutsch"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_English_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_English.Click
        Language = "English"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Espanol_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Espanol.Click
        Language = "Espanol"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Francais_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Francais.Click
        Language = "Francais"
        SetLocales()
        Save_INI()
    End Sub
    Private Sub Menu_Language_Italian_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Menu_Language_Italian.Click
        Language = "Italian"
        SetLocales()
        Save_INI()
    End Sub

    ' =======================================================================================
    '   MENU HELP
    ' =======================================================================================
    Private Sub Menu_Help_ProgramHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ProgramHelp.Click
        OpenLocalizedHelp("ThereminoMCA_Help", ".pdf")
    End Sub
    Private Sub Menu_Help_TestAudioSignal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_TestAudioSignal.Click
        OpenLocalizedHelp("TestAudioSignal", ".pdf")
    End Sub
    Private Sub Menu_Help_SignalConditioning_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_SignalConditioning.Click
        OpenLocalizedHelp("SignalConditioning", ".pdf")
    End Sub
    Private Sub Menu_Help_PmtAdapters_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_PmtAdapters.Click
        OpenLocalizedHelp("PmtAdapters", ".pdf")
    End Sub
    Private Sub Menu_Help_IsotopeIdentifier_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_IsotopeIdentifier.Click
        OpenLocalizedHelp("IsotopeIdentifier_Help", ".pdf")
    End Sub
    Private Sub Menu_Help_Isotopes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_Isotopes.Click
        OpenLocalizedHelp("Isotopes")
    End Sub
    Private Sub Menu_Help_ToDoList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_ToDoList.Click
        OpenLocalizedHelp("ToDo", ".txt")
    End Sub
    Private Sub Menu_Help_OpenProgramFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_Help_OpenProgramFolder.Click
        Process.Start(Application.StartupPath)
    End Sub
    Private Sub OpenLocalizedHelp(ByVal name As String, Optional ByVal ext As String = ".rtf")
        Dim fname As String = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_" & Strings.Left(Language, 3).ToUpper & ext)
        If FileExists(fname) Then
            Process.Start(fname)
        Else
            fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ENG" & ext)
            If FileExists(fname) Then
                Process.Start(fname)
            Else
                fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & "_ITA" & ext)
                If FileExists(fname) Then
                    Process.Start(fname)
                Else
                    fname = PlatformAdjustedFileName(Application.StartupPath & "\Docs\" & name & ext)
                    If FileExists(fname) Then
                        Process.Start(fname)
                    End If
                End If
            End If
        End If
    End Sub


    ' =======================================================================================
    '   MENU ABOUT
    ' =======================================================================================
    Private Sub Menu_About_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Menu_About.Click
        Form_About.ShowDialog()
    End Sub


    ' =======================================================================================
    '   TOOLBAR
    ' =======================================================================================
    Private Sub ToolStripButton_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveImage.Click
        ToolStripButton_SaveImage.Visible = False
        ToolStripButton_SaveImage.Visible = True
        Me.Refresh()
        SaveImage("ThereminoMCA_", Me)
    End Sub
    Private Sub ToolStripButton_Export_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_Export.Click
        SaveHistogramFile(chk_ExportWithHeader.Checked, txt_DecimalSeparator.Text, txt_FieldSeparator.Text)
    End Sub
    Private Sub ToolStripButton_ViewPulses_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_ViewPulses.Click
        If Form_Pulses.Visible Then
            Form_Pulses.Visible = False
        Else
            Form_Pulses.Visible = True
            Me.Focus()
        End If
        DockAllWindows()
    End Sub
    Private Sub ToolStripButton_ViewEqualizers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_ViewEqualizers.Click
        If Form_Equalizers.Visible Then
            Form_Equalizers.Visible = False
        Else
            Form_Equalizers.Visible = True
            Me.Focus()
        End If
        DockAllWindows()
    End Sub
    Private Sub ToolStripButton_Run_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButton_Run.CheckedChanged
        If Not EventsAreEnabled Then Return
        If ToolStripButton_Run.Checked Then
            TestTimerBeforeToStart()
            AudioIn.Enabled = True
        Else
            AudioIn.Enabled = False
        End If
    End Sub
    Private Sub ToolStripButton_StartMeasure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_StartMeasure.Click
        AllBinsToZero()
        ToolStripButton_Run.Checked = True
        GroupBox_SpectrumData.Focus()
    End Sub
    'Private Sub ToolStrip1_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStrip1.MouseHover
    '    Me.Focus() ' with this the toolstrip responds always at the first click
    'End Sub
    Private Sub ToolStrip1_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStrip1.MouseEnter
        Me.Focus() ' with this the toolstrip responds always at the first click
    End Sub


    Private Sub TestTimerBeforeToStart()
        If txt_StopTimer.NumericValueInteger > 0 Then
            MsgBox("Warning: the aquisiton time is limited to " & _
              txt_StopTimer.NumericValueInteger.ToString & " seconds.")
            StartRun()
        End If
    End Sub

    Private Sub StartRun()
        AudioIn.Enabled = False
        AllBinsToZero()
        lbl_TotalSeconds.Text = "0"
        TotalSeconds = 0
        AudioIn.TotalPulses = 0
        AudioIn.ResetBaseLineZero()
        AudioIn.Enabled = True
    End Sub


    ' =======================================================================================
    '   TOOLBAR TOMY
    ' =======================================================================================
    Private Sub ToolStripButton_IsotopeIdentifier_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_Identifier.Click
        If Not EventsAreEnabled Then Return
        EnableDisableTomy()
    End Sub
    Private Sub EnableDisableTomy()
        If IdentiFinder Is Nothing Then IdentiFinder = New Class_Identify
        If Not Form_Tomy.Visible Then
            Form_Tomy.Show(Me)
        End If
        If ToolStripButton_Identifier.Checked Then
            Form_Tomy.TopMost = False
            IdentiFinder.Enable()
        Else
            IdentiFinder.Disable()
            Form_Tomy.Hide()
        End If
    End Sub



    ' ================================================================================================
    '   PBox_Spectrum mouse access
    ' ================================================================================================
    Private Sub PBox_Spectrum_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PBox_Spectrum.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Or e.Button = Windows.Forms.MouseButtons.Right Then
            Spectrometer.SetSelectedBinFromX(e.X)
        End If
        Spectrometer.SnapToPeak = e.Button = Windows.Forms.MouseButtons.Right
    End Sub
    Private Sub PBox_Spectrum_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PBox_Spectrum.MouseMove
        If e.Button = Windows.Forms.MouseButtons.Left Or e.Button = Windows.Forms.MouseButtons.Right Then
            Spectrometer.SetSelectedBinFromX(e.X)
        End If
    End Sub

    Friend Sub ShowSelectedBinData()
        Dim n As Int32
        If Spectrometer.SelectedBin > 0 AndAlso Spectrometer.SelectedBin <= Spectrometer.mLastBinIndex Then
            n = CInt(AudioIn.Bins(Spectrometer.SelectedBin))
            Spectrometer.SelectedEnergy = Spectrometer.XtoEnergy(Spectrometer.BinToX(Spectrometer.SelectedBin))
            StatusLabel2.Text = "Selected Bin=" & Spectrometer.SelectedBin.ToString & _
                                "    Energy=" & Spectrometer.SelectedEnergy.ToString("0.0 KeV") & _
                                "    Samples=" & n.ToString()
            IdentiFinder.IdentifyElements()
        Else
            StatusLabel2.Text = ""
        End If
        TimerDraw.Interval = 100 ' show changes immediately
    End Sub

    Private Sub Form_Main_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If Not Label_Dummy.Focused Then Return
        If e.KeyCode = Keys.Left Then Spectrometer.ChangeSelectedBin(-1)
        If e.KeyCode = Keys.Right Then Spectrometer.ChangeSelectedBin(1)
        If e.KeyCode = Keys.PageDown Then Spectrometer.ChangeSelectedBin(-10)
        If e.KeyCode = Keys.PageUp Then Spectrometer.ChangeSelectedBin(10)
    End Sub

    Private Sub Form_Main_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        If Not Label_Dummy.Focused Then Return
        Spectrometer.ChangeSelectedBin(e.Delta \ 120)
    End Sub

    ' ------------------------------------------ set focus to a dummy label
    Private Sub PBox_Spectrum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PBox_Spectrum.Click
        Label_Dummy.Focus()
    End Sub




    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_AudioGain.LostFocus, _
                                                                          txt_AudioZero.LostFocus, _
                                                                          txt_DeadTime.LostFocus, _
                                                                          chk_BlrEnable.LostFocus, _
                                                                          txt_Blr_Position.LostFocus, _
                                                                          txt_Blr_Size.LostFocus, _
                                                                          txt_IntegrationTime.LostFocus, _
                                                                          txt_DrawSpeed.LostFocus, _
                                                                          txt_MinEnergy.LostFocus, _
                                                                          txt_IIR_Filter.LostFocus, _
                                                                          chk_ExportWithHeader.LostFocus, _
                                                                          txt_DecimalSeparator.LostFocus, _
                                                                          txt_FieldSeparator.LostFocus, _
                                                                          txt_SlotCounter.LostFocus, _
                                                                          txt_BinsFirstSlot.LostFocus, _
                                                                          txt_BinsNumSlots.LostFocus, _
                                                                          txt_StopTimer.LostFocus, _
                                                                          txt_XlogExponent.LostFocus, _
                                                                          txt_YlogExponent.LostFocus, _
                                                                          chk_ThickLines.LostFocus, _
                                                                          txt_UserText.LostFocus, _
                                                                          btn_Xlog.LostFocus, _
                                                                          btn_Ylog.LostFocus, _
                                                                          tk_Zoom.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub


    ' ================================================================================================
    '   OPERATION-TAB COMBO
    ' ================================================================================================
    Private Sub cmb_Bins_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Bins.DropDown
        cmb_Bins.ItemHeight = 15
    End Sub
    Private Sub cmb_Sampling_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Sampling.DropDown
        cmb_Sampling.ItemHeight = 15
    End Sub
    Private Sub cmb_PulsePolarity_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_PulsePolarity.DropDown
        cmb_PulsePolarity.ItemHeight = 15
    End Sub
    Private Sub cmb_Bins_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Bins.DropDownClosed
        If Not EventsAreEnabled Then Return
        cmb_Bins.ItemHeight = 11
        Set_Props()
        Form_Pulses.SetProps()
        'AllBinsToZero()
        Save_INI()
        Label_Dummy.Focus()
    End Sub
    Private Sub cmb_Sampling_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Sampling.DropDownClosed
        If Not EventsAreEnabled Then Return
        cmb_Sampling.ItemHeight = 11
        Set_Props()
        StartAudioReader()
        Save_INI()
        Label_Dummy.Focus()
    End Sub
    Private Sub cmb_PulsePolarity_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_PulsePolarity.DropDownClosed
        If Not EventsAreEnabled Then Return
        cmb_PulsePolarity.ItemHeight = 11
        Set_Props()
        Save_INI()
        Label_Dummy.Focus()
    End Sub
    Private Sub txt_InputDevice_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_InputDevice.TextChanged
        If Not EventsAreEnabled Then Return
        Dim devCount As Int32 = WaveLib.WaveInRecorder.DeviceCount
        If txt_InputDevice.NumericValueInteger >= devCount Then
            txt_InputDevice.NumericValueInteger = devCount - 1
        End If
        Set_Props()
        StartAudioReader()
        Save_INI()
    End Sub
    Private Sub StartAudioReader()
        If AudioIn.RecordStart() Then
            GroupBox_AudioInput.BackColor = GroupBox_OutputSlots.BackColor
        Else
            GroupBox_AudioInput.BackColor = Color.OrangeRed
        End If
    End Sub


    ' ================================================================================================
    '   OPERATION-TAB PROPERTIES
    ' ================================================================================================
    Private Sub txt_AudioGain_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_AudioGain.TextChanged
        If Not EventsAreEnabled Then Return
        AllBinsToZero()
        Set_Props()
    End Sub
    Private Sub txt_AudioZero_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_AudioZero.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_DeadTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_DeadTime.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub

    Private Sub chk_BlrEnable_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_BlrEnable.CheckedChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_Blr_Position_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Blr_Position.TextChanged
        If Not EventsAreEnabled Then Return
        AudioIn.InvalidatePulsePicture()
        Set_Props()
    End Sub
    Private Sub txt_Blr_Size_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Blr_Size.TextChanged
        If Not EventsAreEnabled Then Return
        AudioIn.InvalidatePulsePicture()
        Set_Props()
    End Sub

    Private Sub txt_IntegrationTime_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_IntegrationTime.TextChanged
        If Not EventsAreEnabled Then Return
        AllBinsToZero()
        Set_Props()
    End Sub
    Private Sub txt_DrawSpeed_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_DrawSpeed.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_MinEnergy_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_MinEnergy.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_IIR_Filter_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_IIR_Filter.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub

    ' ================================================================================================
    '   OPTION-TAB PROPERTIES
    ' ================================================================================================
    Private Sub txt_SlotCounterOut_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_SlotCounter.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_BinsFirstSlot_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_BinsFirstSlot.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_BinsNumSlots_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_BinsNumSlots.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_StopTimer_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_StopTimer.TextChanged
        '
    End Sub
    Private Sub txt_XlogExponent_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_XlogExponent.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub txt_YlogExponent_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_YlogExponent.TextChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub chk_ThickLines_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_ThickLines.CheckedChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub


    ' ================================================================================================
    '   Controls
    ' ================================================================================================
    Private Sub btn_SaveAsBkg_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_SaveAsBkg.ClickButtonArea
        btn_UseBkg.Enabled = True
        Spectrometer.BackgroundSave = True
    End Sub
    Private Sub btn_UseBkg_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_UseBkg.CheckedChanged
        Spectrometer.UseReference(0) = btn_UseBkg.Checked
        TimerDraw.Interval = 100
    End Sub
    Private Sub btn_Reference1_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_Reference1.CheckedChanged
        Spectrometer.UseReference(1) = btn_Reference1.Checked
        TimerDraw.Interval = 100
    End Sub
    Private Sub btn_Reference2_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_Reference2.CheckedChanged
        Spectrometer.UseReference(2) = btn_Reference2.Checked
        TimerDraw.Interval = 100
    End Sub
    Private Sub btn_Reference3_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_Reference3.CheckedChanged
        Spectrometer.UseReference(3) = btn_Reference3.Checked
        TimerDraw.Interval = 100
    End Sub
    Private Sub btn_Xlog_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_Xlog.CheckedChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub btn_Ylog_CheckedChanged(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_Ylog.CheckedChanged
        If Not EventsAreEnabled Then Return
        Set_Props()
    End Sub
    Private Sub tk_Zoom_Scroll(ByVal sender As Object, ByVal e As System.EventArgs) Handles tk_Zoom.Scroll
        If Not EventsAreEnabled Then Return
        Set_Props()
        Form_Pulses.SetProps()
    End Sub

    Private Sub tk_EqMaster_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_EqMaster.Scroll
        If Not EventsAreEnabled Then Return
        If MouseButtonLeftPressed() Then
            LockTrackbar(sender)
        End If
        Form_Equalizers.CreateHeightCurve()
        TimerDraw.Interval = 100 ' show changes immediately
    End Sub
    Private Sub tk_EqMaster_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tk_EqMaster.MouseDown
        If Not EventsAreEnabled Then Return
        If MouseButtonRightPressed() Then
            CType(sender, TrackBar).Value = 0
        End If
        Form_Equalizers.CreateHeightCurve()
        TimerDraw.Interval = 100 ' show changes immediately
    End Sub
    Private Sub tk_EqMaster_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tk_EqMaster.ValueChanged
        ' do not test EventsAreEnabled here (to init colors)
        If Math.Abs(tk_EqMaster.Value) < 1 Then
            tk_EqMaster.BackColor = GroupBox_SpectrumData.BackColor
        Else
            tk_EqMaster.BackColor = HighlightColor
        End If
    End Sub
    Private Sub tk_LinMaster_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_LinMaster.Scroll
        If Not EventsAreEnabled Then Return
        If MouseButtonLeftPressed() Then
            LockTrackbar(sender)
        End If
        Form_Equalizers.CreateLinearityCurve()
        ShowSelectedBinData()
        Form_Pulses.SetProps()
        TimerDraw.Interval = 100 ' show changes immediately
    End Sub


    Private Sub Set_Props()
        If EventsAreEnabled Then Application.DoEvents()
        ' ---------------------------------------------------------------- audio in combo params
        If Spectrometer.SetNumBins(1000 * CInt(Val(Mid(cmb_Bins.Text, 2)))) Then
            AllBinsToZero()
        End If
        AudioIn.SamplesPerSec = CInt(Val(cmb_Sampling.Text))
        AutoPolarityTest = cmb_PulsePolarity.Text = "Auto"
        If cmb_PulsePolarity.Text = "Pos." Then AudioIn.NegPulses = False
        If cmb_PulsePolarity.Text = "Neg." Then AudioIn.NegPulses = True
        ' ---------------------------------------------------------------- audio in txt params 
        AudioIn.InputDevice = txt_InputDevice.NumericValueInteger
        AudioIn.BinMultiplier = Spectrometer.GetNumBins / 25000.0F
        AudioIn.AudioGain = CSng(txt_AudioGain.NumericValue)
        AudioIn.AudioZero = txt_AudioZero.NumericValueInteger
        ' ---------------------------------------------------------------- params
        IntegrationTime = txt_IntegrationTime.NumericValueInteger
        Spectrometer.MinEnergy = txt_MinEnergy.NumericValueInteger
        AudioIn.DeadTime_uS = txt_DeadTime.NumericValueInteger
        Spectrometer.Filter = txt_IIR_Filter.NumericValueInteger
        ' ---------------------------------------------------------------- base line restoring
        If chk_BlrEnable.Checked Then
            AudioIn.BLR_Enable = True
            txt_Blr_Position.Enabled = True
            txt_Blr_Size.Enabled = True
        Else
            AudioIn.BLR_Enable = False
            txt_Blr_Position.Enabled = False
            txt_Blr_Size.Enabled = False
        End If
        AudioIn.BLR_Position_uS = txt_Blr_Position.NumericValueInteger()
        AudioIn.BLR_Size_uS = txt_Blr_Size.NumericValueInteger
        ' ---------------------------------------------------------------- slots 
        Slot_Counter = txt_SlotCounter.NumericValueInteger
        Slot_BinsFirstSlot = txt_BinsFirstSlot.NumericValueInteger
        BinsNumSlots = txt_BinsNumSlots.NumericValueInteger
        ' ---------------------------------------------------------------- scale options
        Spectrometer.XlogExponent = txt_XlogExponent.NumericValue
        Spectrometer.YlogExponent = txt_YlogExponent.NumericValue
        ' ---------------------------------------------------------------- graph
        Spectrometer.Xlog = btn_Xlog.Checked
        Spectrometer.Ylog = btn_Ylog.Checked
        Spectrometer.ThickLines = chk_ThickLines.Checked
        ' ---------------------------------------------------------------- zoom
        Spectrometer.ScaleZoom = tk_Zoom.Value
        ' ---------------------------------------------------------------- show non-standard regulations
        If IntegrationTime < 9999 Then
            Label_IntegrationTime.BackColor = Color.PeachPuff
            txt_IntegrationTime.BackColor = Color.PeachPuff
        Else
            Label_IntegrationTime.BackColor = GroupBox_Params.BackColor
            txt_IntegrationTime.BackColor = Color.AliceBlue
        End If
        If txt_AudioZero.NumericValueInteger <> 0 Then
            Label_AudioZero.BackColor = HighlightColor
            txt_AudioZero.BackColor = HighlightColor
        Else
            Label_AudioZero.BackColor = GroupBox_Params.BackColor
            txt_AudioZero.BackColor = Color.AliceBlue
        End If
        ' ---------------------------------------------------------------- show changes immediately
        If TimerDraw.Interval > 100 Then TimerDraw.Interval = 100
        'Spectrometer.Draw()
    End Sub

    Private Sub AllBinsToZero()
        For i As Int32 = 0 To AudioIn.Bins.Length - 1
            AudioIn.Bins(i) = 0
        Next
        TotalSeconds = 0
        AudioIn.TotalPulses = 0
        AudioIn.ResetBaseLineZero()
        AudioIn.Scope_Clear()
    End Sub



    ' ================================================================================================
    '   TIMERS
    ' ================================================================================================
    Private Sub Timer1Sec_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1Sec.Tick
        If Not AudioIn.Enabled Then Return
        ' --------------------------------------------------------------------- Totals
        TotalSeconds += 1
        If IntegrationTime < 9999 Then
            If TotalSeconds > IntegrationTime Then TotalSeconds = IntegrationTime
            Dim n As Single = 0
            For i As Int32 = Spectrometer.mFirstBinIndex To MAX_BIN_INDEX
                n += AudioIn.Bins(i)
            Next
            ValidPulses = CInt(n)
            If TotalSeconds < IntegrationTime Then
                PulsesPerSec = 0
                lbl_PulsesPerSec.Text = "wait"
            Else
                If TotalSeconds > 10 Then
                    PulsesPerSec = ValidPulses / (TotalSeconds * 0.32F)
                Else
                    PulsesPerSec = ValidPulses * 0.32F
                End If
                lbl_PulsesPerSec.Text = PulsesPerSec.ToString("0.0")
            End If
        Else
            ValidPulses = Spectrometer.GetValidPulses
            PulsesPerSec = ValidPulses / CSng(TotalSeconds - 0.5F)
            lbl_PulsesPerSec.Text = PulsesPerSec.ToString("0.0")
        End If
        lbl_TotalSeconds.Text = TotalSeconds.ToString
        lbl_TotalPulses.Text = ValidPulses.ToString
        ' --------------------------------------------------------------------- Audio test
        If SlowPeakMeter > 0.98 Then
            StatusLabel1.BackColor = Color.Orange
            StatusLabel1.TextAlign = ContentAlignment.MiddleCenter
            StatusLabel1.Text = "Too much signal"
        ElseIf SlowPeakMeter < 0.1 Then
            StatusLabel1.BackColor = Color.Orange
            StatusLabel1.TextAlign = ContentAlignment.MiddleCenter
            StatusLabel1.Text = "No audio signal"
        ElseIf SlowPeakMeter < 0.25 Then
            StatusLabel1.BackColor = Color.Orange
            StatusLabel1.TextAlign = ContentAlignment.MiddleCenter
            StatusLabel1.Text = "Too low signal"
        Else
            StatusLabel1.BackColor = Color.LightYellow
            StatusLabel1.TextAlign = ContentAlignment.MiddleLeft
            StatusLabel1.Text = "Signal is OK"
        End If
        ' --------------------------------------------------------------------- Timers
        If txt_StopTimer.NumericValueInteger > 0 AndAlso _
            TotalSeconds >= txt_StopTimer.NumericValueInteger Then
            ToolStripButton_Run.Checked = False
            GroupBox_SpectrumData.Focus()
            Beep()
        End If
    End Sub

    Private SlowPeakMeter As Single
    Private PeakPolarity As Single
    Private Sub Timer10Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer10Hz.Tick
        If ToolStripButton_Run.Checked Then
            ' --------------------------------------------------------------------- reduce counts by integration time
            If IntegrationTime < 9999 Then
                Dim k As Single = 1 - 0.3F / IntegrationTime
                For i As Int32 = 0 To MAX_BIN_INDEX
                    AudioIn.Bins(i) = AudioIn.Bins(i) * k ' 0.995F '- 0.02F
                Next
            End If
            ' --------------------------------------------------------------------- Slot counter
            If Slot_Counter >= 0 Then
                MMF1.WriteSingle(Slot_Counter * 4, AudioIn.Counter)
            End If
            ' --------------------------------------------------------------------- Slot bins
            If Slot_BinsFirstSlot >= 0 Then
                Static OldCounts(999) As Single
                Dim MacroBinSize As Int32 = (Spectrometer.mLastBinIndex - Spectrometer.mFirstBinIndex) \ BinsNumSlots
                If MacroBinSize = 0 Then MacroBinSize = 1
                Dim slot As Int32 = Slot_BinsFirstSlot
                Dim counter As Int32 = 0
                Dim acc As Single = 0
                For i As Int32 = Spectrometer.mFirstBinIndex To Spectrometer.mLastBinIndex
                    acc += AudioIn.Bins(i)
                    'acc += Spectrometer.mValues(i)
                    counter += 1
                    If counter >= MacroBinSize Then
                        '
                        MMF1.WriteSingle(slot * 4, acc - OldCounts(slot))
                        '
                        OldCounts(slot) = acc
                        slot += 1
                        counter = 0
                        acc = 0
                    End If
                Next
            End If
            ' --------------------------------------------------------------------- Pulse polarity tester
            If AutoPolarityTest Then
                If AudioIn.PeakMeter_Positive > -AudioIn.PeakMeter_Negative * 0.9F Then
                    PeakPolarity += 1
                    If PeakPolarity > 1 Then PeakPolarity = 1
                Else
                    ' ------------------------------------------------ if enough signal
                    If AudioIn.PeakMeter_Negative < -1000 Then
                        PeakPolarity -= 1
                        ' -------------------------------------------- if polarity < -2 then change 
                        If PeakPolarity < -2 Then
                            PeakPolarity = -2
                            AudioIn.NegPulses = Not AudioIn.NegPulses
                            AudioIn.AudioZero = -AudioIn.AudioZero
                            txt_AudioZero.NumericValueInteger = AudioIn.AudioZero
                            AllBinsToZero()
                        End If
                    End If
                End If
                ' ----------------------------------------------------------------- test
                'AudioIn.NegPulses = True
                'Text = PeakPolarity.ToString & "  " & _
                '        AudioIn.PeakMeter_Negative.ToString & "  " & _
                '        AudioIn.PeakMeter_Positive.ToString
                ' ----------------------------------------------------------------- clear PeakMmeter_Negative
                AudioIn.PeakMeter_Negative = 0
            End If

            ' --------------------------------------------------------------------- peak meter - ORIGINAL
            'Dim p As Single
            '' ---------------------------------------------- peak meter trimming
            'p = AudioIn.PeakMeter_Positive / 22000
            '' ---------------------------------------------- mean of peaks smoothing
            'MeanOfPeaks += (p - MeanOfPeaks) * 0.03F
            'If MeanOfPeaks > 1 Then MeanOfPeaks = 1
            '' ---------------------------------------------- show meter
            'VuMeter_Vertical(Pbox3, MeanOfPeaks)
            '' ---------------------------------------------- decay speed
            'AudioIn.PeakMeter_Positive -= 1000


            ' --------------------------------------------------------------------- peak meter - NEW
            Dim p As Single
            ' ---------------------------------------------- peak meter trimming
            If AudioIn.PeakMeter_Positive > 32767 Then
                AudioIn.PeakMeter_Positive = 32767
            End If
            p = AudioIn.PeakMeter_Positive / 32768

            ' ---------------------------------------------- logaritmic VuMeter -30dB to 0dB
            If p > 1 Then p = 1
            If p < 0.001 Then p = 0.001
            p = VoltToDecibel(p)
            p = 1 + p / 30

            ' ---------------------------------------------- slow peak meter
            If p > SlowPeakMeter Then
                SlowPeakMeter += (p - SlowPeakMeter) * 0.2F
            Else
                SlowPeakMeter -= 0.01F
            End If
            ' ---------------------------------------------- show meter
            VuMeter_Vertical(Pbox3, p, SlowPeakMeter)
            ' ---------------------------------------------- decay speed
            'AudioIn.PeakMeter_Positive -= 2000
            AudioIn.PeakMeter_Positive *= 0.9F

        Else
            VuMeter_Vertical(Pbox3, 0)
        End If
    End Sub

    Private Sub TimerDraw_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerDraw.Tick
        If Me.WindowState <> FormWindowState.Minimized Then
            'Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
            Spectrometer.Draw()
            'Text = (sw1.Elapsed.TotalMilliseconds * 1000).ToString("0")
            'Text = AudioIn.TimeMicrosec.ToString("AudioIn uS: 0")
            TimerDraw.Interval = 1000 \ txt_DrawSpeed.NumericValueInteger
        End If
    End Sub

End Class