﻿Public Class Form_Pulses

    Private Sub Form_Pulses_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        InitPictureboxImage(PBoxScope)
        AudioIn.Picture_Box = PBoxScope
        Timer1.Interval = 30
        Timer1.Start()
        InitSnap()
    End Sub
    Private Sub Form_Pulses_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        'Save_INI()
        Me.Hide()
        e.Cancel = True
    End Sub
    'Private Sub Form_Pulses_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
    '    If Not EventsAreEnabled Then Return
    'End Sub
    Private Sub Form_Pulses_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        If Me.WindowState = FormWindowState.Minimized Then Return
        InitPictureboxImage(PBoxScope)
        AudioIn.Picture_Box = PBoxScope
        AudioIn.Scope_ShowPulses()
        AudioIn.InvalidatePulsePicture()
    End Sub
    Private Sub Form_Pulses_ResizeEnd(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ResizeEnd
        If Not EventsAreEnabled Then Return
        SetSnap()
    End Sub


    ' =======================================================================================
    '   SNAP WINDOW
    ' =======================================================================================
    Private SnapPosition As Int32 = 0
    ' --------------------------------------------------------------------- InitSmap must be calle from FormLoad
    Private Sub InitSnap()
        ' ---------------------------------- prepare snap params (timer will be disabled automatically)
        SnapMouseMoveTimer.Enabled = True
        TestSnap()
    End Sub
    ' --------------------------------------------------------------------- Start snap when clicking on TitleBar
    Protected Overrides Sub WndProc(ByRef m As Message)
        Const WM_NCLBUTTONDOWN As Integer = 161
        Const HTCAPTION As Integer = 2
        If m.Msg = WM_NCLBUTTONDOWN AndAlso m.WParam.ToInt32 = HTCAPTION Then
            Me.Select()
            Snap_MouseDown()
            Return
        End If
        MyBase.WndProc(m)
    End Sub
    ' --------------------------------------------------------------------- test snap positions
    Private Sub TestSnap()
        Dim newSnap As Int32 = 0
        If Math.Abs(Me.Left - Form_Main.Left) < 40 And Math.Abs(Me.Top - Form_Main.Bottom) < 40 Then newSnap = 1
        If Math.Abs(Me.Left - (Form_Main.Left + 400)) < 40 And Math.Abs(Me.Top - Form_Main.Bottom) < 40 Then newSnap = 2
        If Math.Abs(Me.Left - Form_Main.Right) < 40 And Math.Abs(Me.Top - Form_Main.Top) < 40 Then newSnap = 3
        If Math.Abs(Me.Left - Form_Main.Right) < 40 And Math.Abs(Me.Top - (Form_Main.Top + 320)) < 40 Then newSnap = 4
        If newSnap <> SnapPosition Then
            SnapPosition = newSnap
            If newSnap <> 0 Then
                SnapMouseMoveTimer.Enabled = False
                SetSnap()
            End If
        End If
    End Sub
    ' --------------------------------------------------------------------- set position to snap positions
    '    must be called from MainForm:DockAllWindows and from ResizeEnd
    ' -----------------------------------------------------------------------------------------------------
    Friend Sub SetSnap()
        If Form_Main.Left < -30000 Then Return
        Select Case SnapPosition
            Case 1 : Me.Left = Form_Main.Left : Me.Top = Form_Main.Bottom
            Case 2 : Me.Left = Form_Main.Left + 400 : Me.Top = Form_Main.Bottom
            Case 3 : Me.Left = Form_Main.Right : Me.Top = Form_Main.Top
            Case 4 : Me.Left = Form_Main.Right : Me.Top = Form_Main.Top + 320
        End Select
    End Sub
    ' --------------------------------------------------------------------- move the window with the mouse
    Private CursorStartPos As Point
    Private FormStartPos As Point
    Private WithEvents SnapMouseMoveTimer As Timer = New Timer
    Private Sub Snap_Form_Move(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Move
        If Not SnapMouseMoveTimer.Enabled Then Return
        LimitFormPosition(Me)
        TestSnap()
    End Sub
    Private Sub Snap_MouseDown()
        CursorStartPos = Cursor.Position
        FormStartPos = Me.Location
        SnapMouseMoveTimer.Interval = 15
        SnapMouseMoveTimer.Enabled = True
    End Sub
    Private Sub SnapMouseMoveTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles SnapMouseMoveTimer.Tick
        If MouseButtonLeftPressed() Then
            Me.Location = New Point(FormStartPos.X + Cursor.Position.X - CursorStartPos.X, _
                                    FormStartPos.Y + Cursor.Position.Y - CursorStartPos.Y)
        Else
            SnapMouseMoveTimer.Enabled = False
        End If
    End Sub



    ' =======================================================================================
    '   TOOLBAR
    ' =======================================================================================
    Private Sub ToolStripButton_SaveScopeImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveScopeImage.Click
        ToolStripButton_SaveScopeImage.Visible = False
        ToolStripButton_SaveScopeImage.Visible = True
        Me.Refresh()
        SaveImage("PULSE_SHAPE_", Me)
    End Sub
    Private Sub ToolStripButton_SaveScopeImage_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripButton_SaveScopeImage.MouseHover
        Me.Focus() ' with this the toolstrip responds always at the first click
    End Sub
    'Private Sub ToolStrip1_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStrip1.MouseHover
    '    Me.Focus() ' with this the toolstrip responds always at the first click
    'End Sub


    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_MaxEnergy.LostFocus, _
                                                                          txt_MinEnergy.LostFocus, _
                                                                          btn_Run.LostFocus, _
                                                                          btn_Normalized.LostFocus, _
                                                                          tk_SizeX.LostFocus, _
                                                                          tk_PosY.LostFocus, _
                                                                          tk_SizeY.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub


    ' ================================================================================================
    '   PROPS
    ' ================================================================================================
    Private Sub txt_MaxEnergy_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_MaxEnergy.TextChanged
        If Not EventsAreEnabled Then Return
        SetProps()
    End Sub
    Private Sub txt_MinEnergy_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_MinEnergy.TextChanged
        If Not EventsAreEnabled Then Return
        SetProps()
    End Sub
    Private Sub btn_Run_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Run.ClickButtonArea
        btn_OneShot.Checked = False
        If btn_Run.Checked Then
            AudioIn.Scope_Clear()
        Else
            AudioIn.Scope_Stop()
        End If
        SetProps()
    End Sub
    Private Sub btn_OneShot_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_OneShot.ClickButtonArea
        btn_Run.Checked = False
        AudioIn.Scope_Clear()
    End Sub
    Private Sub btn_Normalize_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_Normalized.ClickButtonArea
        SetProps()
    End Sub
    Private Sub tk_SizeX_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_SizeX.Scroll
        SetProps()
    End Sub
    Private Sub tk_PosY_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_PosY.Scroll
        SetProps()
    End Sub
    Private Sub tk_SizeY_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tk_SizeY.Scroll
        SetProps()
    End Sub

    Friend Sub SetProps()
        txt_MinEnergy.MaxValue = txt_MaxEnergy.NumericValueInteger - 1
        txt_MaxEnergy.MinValue = txt_MinEnergy.NumericValueInteger + 1
        AudioIn.MaxEnergy = txt_MaxEnergy.NumericValueInteger
        AudioIn.MinEnergy = txt_MinEnergy.NumericValueInteger
        AudioIn.SizeX = tk_SizeX.Value
        AudioIn.SizeY = tk_SizeY.Value
        AudioIn.PosY = tk_PosY.Value
        AudioIn.Normalized = btn_Normalized.Checked
        If btn_Normalized.Checked Then
            tk_SizeY.Enabled = False
            tk_PosY.Enabled = False
        Else
            tk_SizeY.Enabled = True
            tk_PosY.Enabled = True
        End If
    End Sub


    ' ================================================================================================
    '   TIMER
    ' ================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        AudioIn.Scope_ShowPulses()
    End Sub

End Class